#include <stdlib.h>

#include <Inventor/Xt/SoXt.h>
#include <Inventor/Xt/SoXtRenderArea.h>
#include <Inventor/nodes/SoCone.h>
#include <Inventor/nodes/SoDirectionalLight.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoPerspectiveCamera.h>
#include <Inventor/nodes/SoSeparator.h>

int main(int argc, char **argv) {

/*	Define variables */
	Widget			window;
	SoSeparator 		*root;
	SoMaterial 		*Material;
	SoXtRenderArea 		*RenderArea;
	SoPerspectiveCamera 	*Camera;
	SoDirectionalLight 	*Light;
	SoCone			*Cone;

/* 	Initialize Variables */
	window = SoXt::init(argv[0]);
	if (window == NULL) exit(1);
	RenderArea = new SoXtRenderArea(window);

/* 	Allocate Memory */
	root 		= new SoSeparator;
	Camera 		= new SoPerspectiveCamera;
	Material 	= new SoMaterial;
	Light 		= new SoDirectionalLight;
	Cone		= new SoCone;

/*	Reference the Root */
	root->ref();

/*	Set parameters */
	Material->diffuseColor.setValue(1.0, 0.0, 0.0);	// RGB tripple 0 - 1.0

/*	Define the SceneGraph  */
	root->addChild(Camera);
	root->addChild(Light);
	root->addChild(Material);
	root->addChild(Cone);

/*	Point the camera at the scenegraph */
	Camera->viewAll(root, RenderArea->getViewportRegion());

/* 	Map the camera to the renderarea */
	RenderArea->setSceneGraph(root);
	RenderArea->show();

/* 	Enter the main loop */
	SoXt::show(window);
	SoXt::mainLoop();
}
