#include <stdlib.h>

#include <Inventor/Xt/SoXt.h>
#include <Inventor/Xt/SoXtRenderArea.h>
#include <Inventor/nodes/SoCone.h>
#include <Inventor/nodes/SoDirectionalLight.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoPerspectiveCamera.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoRotor.h>
#include <Inventor/nodes/SoRotationXYZ.h>
/* THE LINE BELOW IS ADDED */
#include <Inventor/manips/SoTrackballManip.h>



int main(int argc, char **argv) {

/*	Define variables */
	Widget			window;
	SoSeparator 		*root;
	SoMaterial 		*Material;
	SoXtRenderArea 		*RenderArea;
	SoPerspectiveCamera 	*Camera;
	SoDirectionalLight 	*Light;
	SoCone			*Cone;
	SoRotor			*Rotor;
/* ADDED 1 BELOW*/
	SoTrackballManip	*Manip;


/* 	Initialize Variables */
	window = SoXt::init(argv[0]);
	if (window == NULL) exit(1);
	RenderArea = new SoXtRenderArea(window);

/* 	Allocate Memory */
	root 		= new SoSeparator;
	Camera 		= new SoPerspectiveCamera;
	Material 	= new SoMaterial;
	Light 		= new SoDirectionalLight;
	Cone		= new SoCone;
        Rotor		= new SoRotor;;
/* ADDED 1 BELOW */
        Manip		= new SoTrackballManip;
	Rotor->rotation.setValue(1.0, 0.0, 0.0, 1.0);

/*	Reference the Root */
	root->ref();

/*	Set parameters */
	Material->diffuseColor.setValue(1.0, 0.0, 0.0);	// RGB tripple 0 - 1.0

/*	Define the SceneGraph  */
	root->addChild(Camera);
	root->addChild(Light);
        root->addChild(Rotor);
	root->addChild(Material);
/* ADDED  1 BELOW */
	root->addChild(Manip);
	root->addChild(Cone);


/*	Point the camera at the scenegraph */
	Camera->viewAll(root, RenderArea->getViewportRegion());

/* 	Map the camera to the renderarea */
	RenderArea->setSceneGraph(root);
	RenderArea->show();

/* 	Enter the main loop */
	SoXt::show(window);
	SoXt::mainLoop();
}
