#include <stdlib.h>

#include <Inventor/Xt/SoXt.h>
#include <Inventor/Xt/viewers/SoXtExaminerViewer.h>
#include <Inventor/nodes/SoCone.h>
#include <Inventor/nodes/SoDirectionalLight.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoPerspectiveCamera.h>
#include <Inventor/nodes/SoSeparator.h>

int main(int argc, char **argv) {

/* 	Define variables */
	Widget			window;
	SoSeparator		*root;
	SoMaterial		*material;
	SoXtExaminerViewer 	*viewer;

/* 	Initialize variables */
	window = SoXt::init(argv[0]);
	if (window == NULL) exit(1);
	viewer = new SoXtExaminerViewer(window);

/* 	Allocate Memory */
	root 			= new SoSeparator;
	material 		= new SoMaterial;
	root->ref();

/* 	Set variables */
	material->diffuseColor.setValue(1.0, 0.0, 0.0);

/* 	Define the SceneGraph */
	root->addChild(material);
	root->addChild(new SoCone);

/* 	Set the camera */
	viewer->setSceneGraph(root);
	viewer->show();

/* 	Enter the mainloop */
	SoXt::show(window);
	SoXt::mainLoop();
}
