/* FIRST COME THE SYSTEM INCLUDES */
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>

/* THEN COME THE INVENTOR INCLUDES */
#include <Inventor/SoDB.h>
#include <Inventor/Xt/SoXt.h>
#include <Inventor/Xt/viewers/SoXtExaminerViewer.h>
#include <Inventor/nodes/SoSeparator.h>

/* OPEN THE MAIN */
int main(int argc, char **argv) {

	/* DEFINE ALL VARIABLES */
	Widget 			window;
	SoSeparator 		*root;
	SoInput 		*SceneInput;
	SoXtExaminerViewer 	*viewer;

	/* CHECK THE COMMAND LINE */
	if (argc != 2) {
		printf("Usage: %s iv_file\n", *argv);
		printf("\tiv_file\tOpenInventor file (eg gview.iv)\n");
		exit(0);
	}

	/* Initialize Inventor and Xt; create new stuff */
	window 			= SoXt::init(argv[0]);
	viewer 			= new SoXtExaminerViewer(window);
	SceneInput 		= new SoInput;
	root 			= new SoSeparator;

	/* Parse the inventor file */
	SceneInput->openFile(*(argv+1));
		root = SoDB::readAll(SceneInput);
	SceneInput->closeFile();

	/* Display SceneGraph in viewer */
	viewer->setSceneGraph(root);
	viewer->show();

	/* Display viewer window and initialize event handler */
	SoXt::show(window);
	SoXt::mainLoop();
}
